import torch

from typing import Optional
from wearable_mri.regularize.network_dncnn import DnCNN as net

def load_model(device: Optional[torch.device] = torch.device('cpu')):
    """
    Loads the pretrained model for denoising.
    """

    model = net(in_nc=1, out_nc=1, nc=64, nb=17, act_mode='R')
    model.load_state_dict(torch.load('./src/wearable_mri/regularize/dncnn_25.pth'), strict=True)
    model.eval()
    for k, v in model.named_parameters():
        v.requires_grad = False
    model = model.to(device)

    return model